
(* ESERCIZIO: SOLUZIONE
Si vuole fare la stessa cosa dell'esercizio1, in AltriEsercizi10, utilizzando il linguaggio 
OCaml su ParseTree IMMUTABLE. Anche qui, si assumano dati API e ADT, Path, per cammini di
tipi astatto path. 
Si chiede di completare il file ParseTree.ml, nel folder OSoluzione dei linstings allegati, 
e in particolare:\\
(a) Completare il modulo PARSETREE relativo all'API \\
(b) Completare il modulo ParseTree relativo all'ADT, provvedendo a:\\
\spz\spz (1) Scelta di uno Stato Concreto tra i due proposti\\
\spz\spz (2)  AF, I\\
\spz\spz (3) Definizione dei 3 costruttori e dell'operazione set\\
\spz\spz (4) Definizione dell'additional toString\\
*)

open List;;
exception InvalidOperatorException;;
exception IllegalArgException of string;;
type ('a,'b) maybe = Just of 'a | Or of 'b;;

module type PARSETREE =
 sig type ('a,'b) parseTree
 val eTree: unit -> ('a,'b) ParseTree
 val lTree: ('a,'b)maybe -> ('a,'b) ParseTree
 val rTree: 'b -> ('a,'b) ParseTree list -> ('a,'b) parseTree
 val set: ('a,'b)parseTree -> Path.path -> ('a,'b)parseTree -> ('a,'b)parseTree
 val toString: ('a,'b)parseTree -> string
 end;;
 
(* completare con AF, I, additionals e caso di uso *)
module ParseTree =
 (struct 
  type 'a null = Null | Val of 'a
  type ('a,'b) parseTree = {
  		label: ('a,'b)maybe null;
  		sons: ('a,'b)parseTree list;
  		}
  (*
   AF(c) = [] se c.label=Null
   AF(c) = [v- L] se (c.label=(Val(Just v)) && L=c.sons && length c.sons=0)
   					 || (c.label=(Val(Or v)) && L=c.sons)
   I(c) = se c.label=Null allora length(c.sons)=0
  *)
  let lTree v = {label = Val v; sons = [];}
  let rec set this p t = 
  		if (isEmpty p) then this
  		else let n1 = (next p) and q = (rest p) in
  		     if (n1>length this.sons) raise(illegalArgException)
  		     else let rec newSons list k = (match k with
  		     				|1 -> (set (hd list) q t)::(tl list)
  		     				|n when n>0 -> (hd list)::(newSons (tl list) (k-1)))
  		     				|_-> raise(illegalArgExceptiion("set: error in path")
  		     	  in {label = this.label; sons = newSons this.sons n1;}  
end:PARSETREE);;

(* Caso di uso *)

